// Code generated by "enumer -type=OperatorType -json -text -yaml -sql"; DO NOT EDIT.

//
package operatorTypes

import (
	"database/sql/driver"
	"encoding/json"
	"fmt"
)

const _OperatorTypeName = "NAANDOREQNEQGTLTGTEQLTEQ"

var _OperatorTypeIndex = [...]uint8{0, 2, 5, 7, 9, 12, 14, 16, 20, 24}

func (i OperatorType) String() string {
	if i < 0 || i >= OperatorType(len(_OperatorTypeIndex)-1) {
		return fmt.Sprintf("OperatorType(%d)", i)
	}
	return _OperatorTypeName[_OperatorTypeIndex[i]:_OperatorTypeIndex[i+1]]
}

var _OperatorTypeValues = []OperatorType{0, 1, 2, 3, 4, 5, 6, 7, 8}

var _OperatorTypeNameToValueMap = map[string]OperatorType{
	_OperatorTypeName[0:2]:   0,
	_OperatorTypeName[2:5]:   1,
	_OperatorTypeName[5:7]:   2,
	_OperatorTypeName[7:9]:   3,
	_OperatorTypeName[9:12]:  4,
	_OperatorTypeName[12:14]: 5,
	_OperatorTypeName[14:16]: 6,
	_OperatorTypeName[16:20]: 7,
	_OperatorTypeName[20:24]: 8,
}

// OperatorTypeString retrieves an enum value from the enum constants string name.
// Throws an error if the param is not part of the enum.
func OperatorTypeString(s string) (OperatorType, error) {
	if val, ok := _OperatorTypeNameToValueMap[s]; ok {
		return val, nil
	}
	return 0, fmt.Errorf("%s does not belong to OperatorType values", s)
}

// OperatorTypeValues returns all values of the enum
func OperatorTypeValues() []OperatorType {
	return _OperatorTypeValues
}

// IsAOperatorType returns "true" if the value is listed in the enum definition. "false" otherwise
func (i OperatorType) IsAOperatorType() bool {
	for _, v := range _OperatorTypeValues {
		if i == v {
			return true
		}
	}
	return false
}

// MarshalJSON implements the json.Marshaler interface for OperatorType
func (i OperatorType) MarshalJSON() ([]byte, error) {
	return json.Marshal(i.String())
}

// UnmarshalJSON implements the json.Unmarshaler interface for OperatorType
func (i *OperatorType) UnmarshalJSON(data []byte) error {
	var s string
	if err := json.Unmarshal(data, &s); err != nil {
		return fmt.Errorf("OperatorType should be a string, got %s", data)
	}

	var err error
	*i, err = OperatorTypeString(s)
	return err
}

// MarshalText implements the encoding.TextMarshaler interface for OperatorType
func (i OperatorType) MarshalText() ([]byte, error) {
	return []byte(i.String()), nil
}

// UnmarshalText implements the encoding.TextUnmarshaler interface for OperatorType
func (i *OperatorType) UnmarshalText(text []byte) error {
	var err error
	*i, err = OperatorTypeString(string(text))
	return err
}

// MarshalYAML implements a YAML Marshaler for OperatorType
func (i OperatorType) MarshalYAML() (interface{}, error) {
	return i.String(), nil
}

// UnmarshalYAML implements a YAML Unmarshaler for OperatorType
func (i *OperatorType) UnmarshalYAML(unmarshal func(interface{}) error) error {
	var s string
	if err := unmarshal(&s); err != nil {
		return err
	}

	var err error
	*i, err = OperatorTypeString(s)
	return err
}

func (i OperatorType) Value() (driver.Value, error) {
	return i.String(), nil
}

func (i *OperatorType) Scan(value interface{}) error {
	if value == nil {
		return nil
	}

	str, ok := value.(string)
	if !ok {
		bytes, ok := value.([]byte)
		if !ok {
			return fmt.Errorf("value is not a byte slice")
		}

		str = string(bytes[:])
	}

	val, err := OperatorTypeString(str)
	if err != nil {
		return err
	}

	*i = val
	return nil
}
